/*********************************************************************************************************
*
* File                : main.c
* Hardware Environment: 
* Build Environment   : RealView MDK-ARM  Version: 4.20
* Version             : V1.0
* By                  : 
*
*                                  (c) Copyright 2005-2011, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "24C02.h"
#include <string.h>
#include <stdio.h>
#include <math.h> 

#ifdef __GNUC__
  /* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
     set to 'Yes') calls __io_putchar() */
  #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
  #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */

/* Private function prototypes -----------------------------------------------*/
void GPIO_Configuration(void);
void USART_Configuration(void);
uint16_t MAG3110_DataProcess (int MAG3110_XData,int MAG3110_YData);
void MAG3110_STD(void);
/*******************************************************************************
* Function Name  : Delay
* Description    : Delay Time
* Input          : - nCount: Delay Time
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void  Delay (uint32_t nCount)
{
  for(; nCount != 0; nCount--);
}

int MAG3110_XOFF=0,MAG3110_YOFF=0;
int MAG3110_XMax=0,MAG3110_YMax=0,MAG3110_XMin=0,MAG3110_YMin=0;
int MAG3110_XData=0,MAG3110_YData=0;
int ang;
/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
int main(void)
{

	int i;
 	
	GPIO_Configuration();
	USART_Configuration();
	I2C_Configuration();
	printf("\r\n****************************************************************\r\n"); 
	MAG3110_Init(); //ʼMAG3110
	  
	  i= I2C_Read(I2C1,MAG3110_IIC_ADDRESS,WHO_AM_I_REG,0,1);
	  if (i == MAG3110Q_ID)	//ȷϳʼǷɹ
	  {
	    printf("ID:MAG3110Q,OK!\n ");  	     
	  }  
	  else //ʼʧ
	  {
	    printf("ID not identified,FAILED!\n"); 
		//for(;;);//ʼʧ,ֹͣ 	    
	  }
  	while(1)
	{	
		Delay(0xfffff);
		Delay(0xfffff);
			Delay(0xfffff);
		Delay(0xfffff);
			Delay(0xfffff);
		Delay(0xfffff);
	    i=I2C_Read(I2C1,MAG3110_IIC_ADDRESS,STATUS_00_REG,0,1); 
		if(i&ZYXDR_MASK) //ݾ
		{ 	
		MAG3110_STD(); //ȡMAG3110ݣ궨ֵݴ
		printf("The data needs to be calibrated, turning a lap");
		printf("\r\n\r\n");



		printf("\r\nPoint to the south angle%d\r\n",ang);
		}
		else //δ
		{
		printf("ID Failed!\n");
		}	
	}

}
uint16_t MAG3110_DataProcess (int MAG3110_XData,int MAG3110_YData)
{


int MAG3110_Ang;

MAG3110_XData -= MAG3110_XOFF;
MAG3110_YData -= MAG3110_YOFF;
if (MAG3110_XData == 0)
{
if (MAG3110_YData>0)
{
MAG3110_Ang
= 90;
}
else
{
MAG3110_Ang
= 270;
}
}
else if (MAG3110_YData == 0)
{
if (MAG3110_XData>0)
{
MAG3110_Ang
= 0;
}
else
{
MAG3110_Ang
= 180;
}
}
else if ((MAG3110_XData > 0) && (MAG3110_YData > 0))
{
MAG3110_Ang = (atan ( ( (float)MAG3110_YData) / ( (float) MAG3110_XData ) ) )
* 180 / 3.14;
}
else if ((MAG3110_XData < 0) && (MAG3110_YData > 0))
{
MAG3110_XData = -MAG3110_XData;
MAG3110_Ang = 180
-
(atan ( ( (float)MAG3110_YData) / ( (float)
MAG3110_XData ) ) ) * 180 / 3.14;
}
else if ((MAG3110_XData < 0) && (MAG3110_YData < 0))
{
MAG3110_XData = -MAG3110_XData;
MAG3110_YData = -MAG3110_YData;
MAG3110_Ang = (atan ( ( (float)MAG3110_YData) / ( (float) MAG3110_XData ) ) )
* 180 / 3.14 + 180;
}
else if ((MAG3110_XData > 0) && (MAG3110_YData < 0))
{
MAG3110_YData = -MAG3110_YData;
MAG3110_Ang = 360
-
(atan ( ( (float)MAG3110_YData) / ( (float)
MAG3110_XData ) ) ) * 180 / 3.14;
}

return 	 MAG3110_Ang;
}


/*************************************************************************/
void MAG3110_STD(void)
// ˺ִԱ֤תһȦ
{
// ܹɼʵֵСֵ
	tword wx, wy, wz; 
	static   uint8_t	First_Flag=0;
	wx.mbyte.hi = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_X_MSB_REG,0,1); //ȡXֽ
	wx.mbyte.lo = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_X_LSB_REG,0,1); //ȡXֽ
	wy.mbyte.hi = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_Y_MSB_REG,0,1); //ȡYֽ
	wy.mbyte.lo = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_Y_LSB_REG,0,1); //ȡYֽ
	wz.mbyte.hi = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_Z_MSB_REG,0,1); //ȡZֽ
	wz.mbyte.lo = I2C_Read(I2C1,MAG3110_IIC_ADDRESS,OUT_Z_LSB_REG,0,1); //ȡZֽ
	printf("X:%d  ",wx.mbyte.hi*256+wx.mbyte.lo);
	printf("Y:%d  ",wy.mbyte.hi*256+wy.mbyte.lo);
	printf("Z:%d  ",wz.mbyte.hi*256+wz.mbyte.lo);
	
	
	MAG3110_XData=wx.mbyte.hi*256+wx.mbyte.lo;
	MAG3110_YData=wy.mbyte.hi*256+wy.mbyte.lo;
	
	if (!First_Flag)
	{
	MAG3110_XMax = MAG3110_XData;
	MAG3110_XMin = MAG3110_XData;
	MAG3110_YMax = MAG3110_YData;
	MAG3110_YMin = MAG3110_YData;
	First_Flag = 1;
	}
	if (MAG3110_XData > MAG3110_XMax)
	{
	MAG3110_XMax =  MAG3110_XData;
	}
	else if (MAG3110_XData < MAG3110_XMin)
	{
	MAG3110_XMin =  MAG3110_XData;
	}
	if (MAG3110_YData > MAG3110_YMax)
	{
	MAG3110_YMax =  MAG3110_YData;
	}
	else if (MAG3110_YData < MAG3110_YMin)
	{
	MAG3110_YMin =  MAG3110_YData;
	}
	MAG3110_XOFF = (MAG3110_XMax + MAG3110_XMin) / 2;
	MAG3110_YOFF = (MAG3110_YMax + MAG3110_YMin) / 2;
	
    printf("\r\nMAG3110_XMax%d ",MAG3110_XMax);
	printf("MAG3110_XMin%d\r\n",MAG3110_XMin);
    printf("MAG3110_XOFF%d\r\n",MAG3110_XOFF);

    printf("\r\nMAG3110_YMax%d  ",MAG3110_YMax);
	printf("MAG3110_YMin%d\r\n ",MAG3110_YMin);
    printf("AG3110_YOFF%d\r\n",MAG3110_YOFF);

	ang=MAG3110_DataProcess(wx.mbyte.hi*256+wx.mbyte.lo,wy.mbyte.hi*256+wy.mbyte.lo);
}



/*******************************************************************************
* Function Name  : GPIO_Configuration
* Description    : Configure GPIO Pin
* Input          : None
* Output         : None
* Return         : None
* Attention		 : None
*******************************************************************************/
void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOC , ENABLE); 						 
/**
 *  LED1 -> PC9 , LED2 -> PC10 , LED3 -> PC11 , LED4 -> PC12
 */					 
  GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
  GPIO_Init(GPIOC, &GPIO_InitStructure);
}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*********************************************************************************************************
      END FILE
*********************************************************************************************************/

